#include "stdafx.h"
// INT8_MINƂĒ`ƌ̂ŁccD
#pragma warning(disable:4005)
#include <boost/spirit/include/qi.hpp>
#pragma warning(default:4005)
#include <boost/spirit/include/phoenix.hpp>
#include <functional>
#include "Calc.h"

// RpCxȂ̂Ŏ𕪗cc
class Calc_impl{
private:
	struct Grammer : boost::spirit::qi::grammar<const TCHAR*, intptr_t(),boost::spirit::ascii::space_type>{
		struct var : public boost::spirit::qi::symbols<TCHAR, intptr_t>{
			var(){}
		}variable;
		
		boost::spirit::qi::rule<const TCHAR*, intptr_t(),boost::spirit::ascii::space_type> expr,term,fctr,func,maxfunc,minfunc;

		Grammer();
	}m_grammer;

public:
	Calc_impl() : m_lastresult(0){}
	intptr_t SetVariable(const TCHAR *name, intptr_t val){m_grammer.variable.add(name,val);return val;}
	intptr_t Parse(const TCHAR *s){return boost::spirit::qi::phrase_parse(s,s + ::lstrlen(s),m_grammer,boost::spirit::ascii::space,m_lastresult) ? TRUE : FALSE;}
	intptr_t GetLastResult(){return m_lastresult;}

private:
	intptr_t m_lastresult;
};

Calc::Calc(){
	m_impl = new Calc_impl();
}

Calc::~Calc(){
	delete m_impl;
}

intptr_t Calc::SetVariable(const TCHAR *name, intptr_t val){return m_impl->SetVariable(name,val);}
intptr_t Calc::Parse(const TCHAR *s){return m_impl->Parse(s);}
intptr_t Calc::GetLastResult(){return m_impl->GetLastResult();}

Calc_impl::Grammer::Grammer() : Calc_impl::Grammer::base_type(expr) {
	using namespace boost::spirit;
	using boost::phoenix::bind;
	expr = (term[_val = _1] | '-' >> term[_val = -_1]) >> *(('+' >> term[_val += _1]) | ('-' >> term[_val -= _1]));
	term = fctr[_val = _1] >> *(('*' >> fctr[_val *= _1]) | ('/' >> fctr[_val /= _1]));
	fctr = int_ | variable | ('(' >> expr >> ')') | func;
	func = maxfunc | minfunc;
	maxfunc = (lit("max") >> '(' >> expr >> ',' >> expr >> ')')[_val = bind([](intptr_t a, intptr_t b) {return std::max(a, b); }, _1, _2)];
	minfunc = (lit("min") >> '(' >> expr >> ',' >> expr >> ')')[_val = bind([](intptr_t a, intptr_t b) {return std::min(a, b); }, _1, _2)];
}

