#ifndef __COLLECTSTR_H__
#define __COLLECTSTR_H__

#include <stdio.h>
#include <vector>
#include <HmJre_dll/RegEx.h>

/** K\ɂ镶WNX
* 
* t@C當W߂Bgrepɋ߂B
* ɂ͐K\gp\BRegExNXgB
*/

class CollectStr
{
public:
	static const int COMMENTLINES = 2;
	CollectStr(){m_regexp.SetOpt(_T("zero_match"),false);}
	~CollectStr(){}
	intptr_t Collect(const TCHAR *fname,const TCHAR *reg,const TCHAR *getstr);
	intptr_t Close();
	intptr_t Set(const TCHAR *set,const TCHAR *val);
	intptr_t SetOpt(const TCHAR *set,intptr_t val);
	intptr_t ClearStr(){m_collectdata.clear();return TRUE;}
	intptr_t GetDataSize(){return m_collectdata.size();}
	const TCHAR *GetStr(intptr_t i);
	const TCHAR *GetComment(intptr_t i);
	intptr_t GetLine(intptr_t i);

private:
	intptr_t LineSearch(const TCHAR *str,const TCHAR *getstr,FILE *fout,FILE *comment,const std::vector<ablib::string> &write = std::vector<ablib::string>(), intptr_t line = 0);
	HmJre::RegEx m_regexp;
	void UnEscape(ablib::string &str);
//	bool Match(TCHAR *str,TCHAR *out,TCHAR *rv);
	struct CollectData{
		ablib::string str,comment;
		intptr_t line;
	};
	std::vector<CollectData> m_collectdata;
	struct COLLECTSET{
		ablib::string output;
		ablib::string comment;
	}m_set;

	NOCOPY(CollectStr);
};

#endif //__COLLECTSTR_H__

