#include "stdafx.h"
#include <HmJre_dll/RegEx.h>
#include <ablib/KRSearch.h>
#include "ForString.h"
#include "func.h"

#define STR_LEN 4096

String::String(void){
	m_splitnum = 0;
	m_uniqi = m_uniq.begin();
}


String::~String(void){
}

intptr_t String::SplitStr(const TCHAR *str,const TCHAR *key, intptr_t regular){
	m_split.clear();
	if(!split(m_split, str, key, regular))return FALSE;
	m_splitnum = 0;
	return TRUE;
}

const TCHAR *String::GetSplitStr(){
	if(m_splitnum == m_split.size())return _T("");
	++m_splitnum;
	return m_split[m_splitnum - 1].c_str();
}

intptr_t String::IsMoreSplitStr(){
	if(m_splitnum >= m_split.size())return FALSE;
	else return TRUE;
}

intptr_t String::ClearSortStr(){
	m_sort.clear();
	return TRUE;
}

intptr_t String::SetSortStr(const TCHAR *str){
//	m_sort.AddStr(str);
	m_sort.insert(str);
	return TRUE;
}

intptr_t String::SortStr(){
//	::qsort(m_sort.m_str,m_sort.m_num,sizeof(PTCHAR),compare);
//	m_sortnum = 0;
	m_sorti = m_sort.begin();
	return TRUE;
}

intptr_t String::IsMoreSortStr(){
	if(m_sorti == m_sort.end())return FALSE;
	else return TRUE;
}

const TCHAR *String::GetSortStr(){
	if(m_sorti == m_sort.end())return _T("");
	return (*(m_sorti++)).c_str();
}


intptr_t String::ClearUniqStr(){
	m_uniq.clear();
	return TRUE;
}

intptr_t String::SetUniqStr(const TCHAR *str){
	m_uniq.insert(str);
	return TRUE;
}

intptr_t String::UniqStr(){
	m_uniqi = m_uniq.begin();
	return TRUE;
}

intptr_t String::IsMoreUniqStr(){return (m_uniqi != m_uniq.end());}

const TCHAR *String::GetUniqStr(){
	if(m_uniqi == m_uniq.end())return _T("");
	return (*(m_uniqi++)).c_str();
}

bool String::split(std::vector<ablib::string> &rvalue, const TCHAR *value, const TCHAR *key, intptr_t regular) {
	DEBUGSTRING("String::split: value = %s, key = %s", value, key);
	TCHAR *p, *q, *string = new TCHAR[::lstrlen(value) + 1], tmp;
	::lstrcpy(string, value);
	q = string;
	if (regular) {
		HmJre::RegEx reg(key);
		if (!reg.IsCompiled()) {
			ablib::string s;
			if (reg.GetErrorMessage(s))SetmacrodllLastError(s);
			return false;
		}
		while (reg.Match(q)) {
			p = q + reg.GetMatchLen();
			tmp = *p; *p = '\0';
			rvalue.push_back(q);
			*p = tmp; q = p + ::lstrlen(key);
		}
	} else {
		while (p = ::_tcsstr(q, key)) {
			DEBUGSTRING("search: from = %s", q);
			DEBUGSTRING("found: %s", p);
			tmp = *p; *p = '\0';
			rvalue.push_back(q);
			*p = tmp; q = p + ::lstrlen(key);
		}
		DEBUGSTRING("search: from = %s", q);
		DEBUGSTRING("not found");
	}
	rvalue.push_back(q);
	delete[] string;
	return true;
}
