#ifndef __STRING_H__
#define __STRING_H__

#include <vector>
#include <set>

/**
񑀍֐ẂB
ԈĂ^ł͂ȂB
*/

class String
{
public:
	String(void);
	~String(void);
	intptr_t SplitStr(const TCHAR *str,const TCHAR *key, intptr_t regular);
	const TCHAR *GetSplitStr();
	intptr_t IsMoreSplitStr();

	intptr_t ClearSortStr();
	intptr_t SetSortStr(const TCHAR *str);
	intptr_t SortStr();
	intptr_t IsMoreSortStr();
	const TCHAR *GetSortStr();

	intptr_t ClearUniqStr();
	intptr_t SetUniqStr(const TCHAR *str);
	intptr_t UniqStr();
	intptr_t IsMoreUniqStr();
	const TCHAR *GetUniqStr();

	static bool split(std::vector<ablib::string> &rvalue, const TCHAR *value, const TCHAR *key, intptr_t regular = FALSE);


private:
	std::vector<ablib::string> m_split;
	std::multiset<ablib::string> m_sort;
	std::multiset<ablib::string>::iterator m_sorti;
	std::set<ablib::string> m_uniq;
	std::set<ablib::string>::iterator m_uniqi;
	UINT m_splitnum;

	NOCOPY(String);
};

#endif //__STRING_H__