#ifndef __HASH_H__
#define __HASH_H__

#include <map>
#include <vector>

struct HashStrStr{
public:
	HashStrStr(){m_ite = m_hash.end();}
	~HashStrStr(){}
	const TCHAR *Get(const TCHAR *name, intptr_t i){
		if(i < 0)return _T("");
		std::map<ablib::string,std::vector<ablib::string> >::iterator ite = m_hash.find(name);
		if(ite == m_hash.end())return _T("");
		else if(static_cast<int>(ite->second.size()) <= i)return _T("");
		else return ite->second[i].c_str();
	}
	intptr_t Erase(const TCHAR *name){m_hash.erase(name);m_ite = m_hash.end();return TRUE;}
	intptr_t Exist(const TCHAR *name){return (m_hash.find(name) != m_hash.end());}
	intptr_t Enum(){m_ite = m_hash.begin();return TRUE;}
	const TCHAR *Next(){if(m_ite == m_hash.end())return _T("");else return (m_ite++)->first.c_str();}
	intptr_t IsMore(){return (m_ite != m_hash.end());}
	std::map<ablib::string,std::vector<ablib::string> > m_hash;
	std::map<ablib::string,std::vector<ablib::string> >::iterator m_ite;
};

struct HashStrInt {
public:
	HashStrInt() { m_ite = m_hash.end(); }
	~HashStrInt() {}
	intptr_t Get(const TCHAR *name){
		auto ite = m_hash.find(name);
		if (ite == m_hash.end())return 0;
		else return ite->second;
	}
	intptr_t Set(const TCHAR *name, intptr_t val) {
		m_ite = m_hash.end();
		m_hash[name] = val;
		return 0;
	}
	intptr_t Erase(const TCHAR *name) { m_hash.erase(name); m_ite = m_hash.end(); return TRUE; }
	intptr_t Exist(const TCHAR *name) { return (m_hash.find(name) != m_hash.end()); }
	intptr_t Enum() { m_ite = m_hash.begin(); return TRUE; }
	const TCHAR *Next() { if (m_ite == m_hash.end())return _T(""); else return (m_ite++)->first.c_str(); }
	intptr_t IsMore() { return (m_ite != m_hash.end()); }
	std::map<ablib::string, intptr_t> m_hash;
	std::map<ablib::string, intptr_t>::iterator m_ite;
};


#endif //__HASH_H__

