#ifndef __STDAFX_H__
#define __STDAFX_H__

#ifndef NDEBUG
#ifndef _CRTDBG_MAP_ALLOC
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#endif
#endif

#define NOMINMAX
#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include <commctrl.h>
#pragma warning( disable : 4091 )
#include <Shlobj.h>
#include <atlbase.h>
#include <atlapp.h>
#include <atlwinx.h>
#include <atlcrack.h>

//͎g܂
#include <ablib/string.h>

#ifdef __cplusplus
#define EXPORT extern "C" __declspec(dllexport)
#else
#define EXPORT __declspec(dllexport)
#endif //__cplusplus

//Rs[֎~
#define NOCOPY(T) T( const T& ); T& operator=( const T& )

//[
#ifndef ASSERT
	#ifdef NDEBUG
		#define ASSERT(C)
	#else
		#include <assert.h>
		#define ASSERT(C) assert(C)
	#endif
#endif

//ł΂p
#ifndef __DEBUGSTRING__
	#define __DEBUGSTRING__
	#ifdef NDEBUG
		inline void DEBUGSTRINGA(const char *fmt,...){ MessageBox(NULL, "naa", NULL, 0); }
		inline void DEBUGSTRINGW(const wchar_t *fmt,...){ MessageBox(NULL, "nww", NULL, 0); }
	#else
		#include <stdarg.h>
		#include <stdio.h>
		inline void DEBUGSTRINGA(const char *fmt,...){
			MessageBox(NULL, "aa", NULL, 0);
			va_list args;
			va_start(args,fmt);
			int size = ::_vscprintf(fmt,args);
			char *buf = new char[size + 1];
			if(buf){
				::vsprintf(buf,fmt,args);
				::OutputDebugStringA(buf);
				::OutputDebugStringA("\n");
				delete[] buf;
			}
			va_end(args);
		}
		inline void DEBUGSTRINGW(const wchar_t *fmt,...){
			MessageBox(NULL, "ww", NULL, 0);
			va_list args;
			va_start(args,fmt);
			int size = ::_vscwprintf(fmt,args);
			wchar_t *buf = new wchar_t[size + 1];
			if(buf){
				::vswprintf(buf,size,fmt,args);
				::OutputDebugStringW(buf);
				::OutputDebugStringW(L"\n");
				delete[] buf;
			}
			va_end(args);
		}
	#endif
#endif

#ifdef UNICODE
#define DEBUGSTRING DEBUGSTRINGW
#else
#define DEBUGSTRING DEBUGSTRINGA
#endif

#ifndef __LASTERROR_OUTPUT__
	#define __LASTERROR_OUTPUT__
	#ifdef NDEBUG
		inline void OUTPUTLASTERROR(DWORD){};
		inline void OUTPUTLASTERROR(){};
	#else
		inline void OUTPUTLASTERROR(DWORD err = ::GetLastError()){
			TCHAR buf[4096],buf2[4096];
			::FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS, 0, err,MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), buf, 4095, 0);
			::_stprintf(buf2,_T("%d: %s"),err,buf);
			::OutputDebugString(buf2);
		}
	#endif
#endif

const TCHAR *GetmacrodllLastError();
void SetmacrodllLastError(const TCHAR *code);
void SetmacrodllLastError(const ablib::string &err);
void SetmacrodllLastError(DWORD code = ::GetLastError());

#endif //__STDAFX_H__
