#ifndef __EDIT_H__
#define __EDIT_H__

#include <set>
#include <window/BaseModalDlg.h>
#include <window/SubClassWnd.h>

/** ⊮pXg{bNXt̃_CAO񋟂D
*/

class Edit : public ablib::window::BaseModalDlg
{
public:
	Edit();
	~Edit(){}
	const TCHAR *Create(HWND hwnd,const TCHAR *listfile,const TCHAR *title,const TCHAR *str = NULL);
	intptr_t SetPos(intptr_t x, intptr_t y){m_pos.x = (int)x;m_pos.y = (int)y;return TRUE;}

private:
	class EditDlg : public ablib::window::SubClassDlg{
	public:
		void SetList(const std::set<ablib::string> &list){m_list = list;}
		const TCHAR *GetResult() const{return m_rv.c_str();}
		void ResetResultStr(){m_rv = _T("");}
	private:
		bool OnChar(ablib::window::Dialog *wnd,TCHAR ch, intptr_t repeat);
		bool OnKey(ablib::window::Dialog *wnd,bool isDown,UINT vk, intptr_t repeat);
		INT_PTR OnOtherMessage(ablib::window::Dialog *wnd,UINT msg,WPARAM wParam,LPARAM lParam);

		std::set<ablib::string> m_list;
		bool CtrlKey(TCHAR c);
		void SelectFromText(const ablib::string &text);
		ablib::string GetCommonStr(const ablib::string &str);
		ablib::string m_rv;
		friend class Edit;
	}m_edit;

	bool OnInitDialog(ablib::window::Dialog *wnd);
	bool OnCommand(ablib::window::Dialog *wnd,int id, intptr_t param);
	ablib::string m_title,m_list,m_defstr;
	ablib::window::Point m_pos;
	NOCOPY(Edit);
};

#endif //__EDIT_H__

