#include "stdafx.h"
#include "Env.h"
#include <ablib/SmallBuffer.h>

intptr_t Env::Set(const TCHAR *name,const TCHAR *val){
	int bufsize;
	ablib::SmallBuffer<TCHAR> buf;
	if(m_original.find(name) == m_original.end()){
		bufsize = ::GetEnvironmentVariable(name,NULL,0);
		if(bufsize != 0){
			buf.Alloc(bufsize+1);
			::GetEnvironmentVariable(name,buf.buf,(DWORD)buf.size);
			m_original[name] = std::pair<ablib::string,bool>(buf.buf,true);
		}else m_original[name] = std::pair<ablib::string,bool>(_T(""),false);
	}
	//ϐݒ
	bufsize = ::ExpandEnvironmentStrings(val,NULL,0);
	if(bufsize == 0){
		::SetmacrodllLastError();
		return FALSE;
	}
	buf.Alloc(bufsize + 1);
	if(!::ExpandEnvironmentStrings(val,buf.buf,(DWORD)buf.size)){
		::SetmacrodllLastError();
		return FALSE;
	}
	if(!::SetEnvironmentVariable(name,buf.buf)){
		::SetmacrodllLastError();
		return FALSE;
	}else return TRUE;
}

intptr_t Env::Restore(){
	for (auto pair : m_original){
		if(pair.second.second)::SetEnvironmentVariable(pair.first.c_str(),pair.second.first.c_str());
		else ::SetEnvironmentVariable(pair.first.c_str(),NULL);
	}
	return TRUE;
	m_original.clear();
}
