#include "stdafx.h"
#include <vector>
#include <hmjre_dll/RegEx.h>
#include <ablib/IsKanji.h>
#include "exportfunc.h"
#include "func.h"
extern ablib::string tmp_string;


EXPORT const TCHAR *TRANSLIKESPRINTF(TCHAR *str , ...){
    ablib::string rv;
	DEBUGSTRING(_T("macrodll.dll:TRANSLIKESPRINTF: str = `%s'"),str);
	SetmacrodllLastError(_T(""));
	if(::IsBadStringPtr(str,1) != FALSE)return _T("");
	std::vector<ablib::string> sa;
	std::vector<TCHAR> syosiki;
	TCHAR tmpchar,*tmpstr,tmpstr2[5];
	va_list args;
	UINT i;
	va_start(args,str);
	rv = _T("");
	bool parcent;
	while(true){
		tmpchar = va_arg(args,TCHAR);
		if(tmpchar == 0)break;
		syosiki.push_back(tmpchar);
		tmpstr = va_arg(args,PTCHAR);
		if(::IsBadStringPtr(tmpstr,1) != FALSE){
			va_end(args);
			SetmacrodllLastError(_T("Óȕ|C^w肳܂łD"));
			return _T("");
		}
		sa.push_back(tmpstr);
	}
	va_end(args);
	tmpstr2[2] = '\0';
	while(*str){
#ifndef UNICODE
		if(ablib::IsKanji(*str)){
			tmpstr2[0] = *str;tmpstr2[1] = *(str+1);
			rv += tmpstr2;
			str = str + 2;
			continue;
		}
#endif
		if(*str == '%'){
			++str;
			if(*str == '%'){
				rv += _T("%");
				++str;
				continue;
			}
			parcent = false;
			for(i = 0 ; i < sa.size() ; ++i){
				if(*str == syosiki[i]){
					rv += sa[i];
					++str;
					parcent = true;
					break;
				}
			}
			if(parcent)continue;
			tmpstr2[0] = '%';tmpstr2[1] = *str;
			++str;
			rv += tmpstr2;
			continue;
		}else{
			tmpstr2[0] = *str;tmpstr2[1] = '\0';
			rv += tmpstr2;
			++str;
			continue;
		}
	}
	tmp_string = rv;
	return tmp_string.c_str();
}

const TCHAR *ExportFunc::ToUpper(const TCHAR *str){
	tmp_string = str;
	tmp_string.toupper();
	return tmp_string.c_str();
}

const TCHAR *ExportFunc::ToLower(const TCHAR *str){
	tmp_string = str;
	tmp_string.tolower();
	return tmp_string.c_str();
}

intptr_t ExportFunc::stristr(const TCHAR *str1,const TCHAR *str2){
	if(!*str2)return -1;
	ablib::string s1 = str1,s2 = str2;
	s1.tolower();s2.tolower();
	auto rv = s1.find(s2);
	return rv == ablib::string::npos ? -1 : rv;
}

const TCHAR *ExportFunc::GSUB(const TCHAR *str,const TCHAR *reg,const TCHAR *getstr, intptr_t casesense, intptr_t word){
	HmJre::RegEx regex;
	regex.SetOpt(_T("zero_match"),false);
	regex.SetOpt(_T("word"),word != FALSE);
	regex.SetOpt(_T("CaseSense"),casesense != FALSE);
	if(!regex.Compile(reg))return _T("");
	tmp_string = _T("");tmp_string.reserve(::lstrlen(str));
	while(*str && regex.Match(str)){
		tmp_string.append(str,0,regex.GetMatchPos());
		tmp_string += regex.GetMatchStr(getstr);
		str += regex.GetMatchPos() + regex.GetMatchLen();
	}
	tmp_string += str;
	return tmp_string.c_str();
}

HmJre::RegEx *g_RegEx = nullptr;
bool g_IsMatched = false;

const TCHAR *ExportFunc::Matchstr(const TCHAR *str,const TCHAR *reg,const TCHAR *getstr, intptr_t casesense, intptr_t word){
    DEBUGSTRING("regex new");
	if(g_RegEx == nullptr)g_RegEx = new HmJre::RegEx();
    DEBUGSTRING("regex setopt");
	g_RegEx->SetOpt(_T("word"),word != FALSE);
	g_RegEx->SetOpt(_T("CaseSense"),casesense != FALSE);
    DEBUGSTRING("regex compile");
	if(!g_RegEx->Compile(reg)){
		SetmacrodllLastError(_T("K\܂D"));
		return _T("");
	}
    DEBUGSTRING("regex match");
	g_IsMatched = g_RegEx->Match(str);
	if(!g_IsMatched)return _T("");
    DEBUGSTRING("regex getmatchstr");
	return g_RegEx->GetMatchStr(getstr);
}

intptr_t ExportFunc::Matchpos(const TCHAR *str,const TCHAR *reg, intptr_t casesense, intptr_t word){
	if(g_RegEx == nullptr)g_RegEx = new HmJre::RegEx();
	g_RegEx->SetOpt(_T("word"),word != FALSE);
	g_RegEx->SetOpt(_T("CaseSense"),casesense != FALSE);
	if(!g_RegEx->Compile(reg)){
		SetmacrodllLastError(_T("K\܂D"));
		return -1;
	}
	g_IsMatched = g_RegEx->Match(str);
	if(!g_IsMatched)return -1;
	return g_RegEx->GetMatchPos();
}

const TCHAR *ExportFunc::GetLastMatchStr(intptr_t i){
	if(g_RegEx == nullptr || !g_IsMatched)return _T("");
	return g_RegEx->GetMatchStr((int)i);
}

intptr_t ExportFunc::GetLastMatchPos(intptr_t i){
	if(g_RegEx == nullptr || !g_IsMatched)return -1;
	return g_RegEx->GetMatchPos((int)i);
}

intptr_t ExportFunc::GetLastMatchLen(intptr_t i){
	if(g_RegEx == nullptr || !g_IsMatched)return -1;
	return g_RegEx->GetMatchLen((int)i);
}