#ifndef __MENU_H__
#define __MENU_H__

#include <map>
#include <window/Window.h>

class Menu{
public:
	Menu() : m_parent(NULL){m_str2int[_T("")] = 0;m_int2str.push_back(_T(""));}
	~Menu(){delete m_parent;}

	intptr_t SetParent(HWND hwnd){delete m_parent;m_parent = new ablib::window::Window(hwnd);return TRUE;}
	intptr_t AddMenu(const TCHAR *parent,const TCHAR *id,const TCHAR *str);
	intptr_t DeleteMenu(const TCHAR *id);
	const TCHAR *CreatePopupMenu(intptr_t x, intptr_t y);
	intptr_t Clear();

private:
	intptr_t AddRootMenu(const TCHAR *id,const TCHAR *str);

	ablib::window::Window *m_parent;
	std::map<ablib::string, intptr_t> m_str2int;
	std::vector<ablib::string> m_int2str;

	
//	static LRESULT CALLBACK sGetMsgProc(int code,WPARAM wParam,LPARAM lParam);
//	LRESULT GetMsgProc(int code,WPARAM wParam,LPARAM lParam);

//	static HHOOK m_hook;
	

};

#endif //__MENU_H__

