#include "stdafx.h"
#include "Process.h"


Process::~Process(void){
	for(auto *i : m_process){
//		if(!i->process.HasExited())i->process.Kill();
		delete i;
	}
}

intptr_t Process::Start(const TCHAR *arg, const TCHAR *wdir, intptr_t std, intptr_t stillalive){
	ablib::system::Process::ProcessStartInfo si;
	si.RedirectStandardError = si.RedirectStandardOutput = (std ? true : false);
	si.RedirectStandardInput = false;
	si.WorkingDirectory = wdir;
	si.Arguments = arg;

	ProcessInfo *pi = new ProcessInfo();;
	pi->process.SetStillAlive(stillalive ? true : false);
	pi->process.StartInfo(si);
	if(!pi->process.Start()){
		SetmacrodllLastError(ablib::system::GetLastError());
		return 0;
	}else{
		m_process.push_back(pi);
		return m_process.size();
	}
}

intptr_t Process::WaitForExit(intptr_t handle){
	if(!CheckHandle(handle))return FALSE;
	if(m_process[handle-1]->process.StartInfo().RedirectStandardOutput){
		TCHAR buf[4096];
		do{
			DWORD readsize;
			do{
				readsize = m_process[handle-1]->process.Read(buf,4093);
				buf[readsize] = '\0';
				m_process[handle-1]->out += buf;
			}while(readsize != 0);
		}while(!m_process[handle-1]->process.HasExited());
		return TRUE;
	}else{
		if(!m_process[handle-1]->process.WaitForExit()){
			::SetmacrodllLastError();
			return FALSE;
		}else return TRUE;
	}
}

intptr_t Process::WaitForInputIdle(intptr_t handle){
	if(!CheckHandle(handle))return FALSE;
	if(!m_process[handle-1]->process.WaitForInputIdle()){
		::SetmacrodllLastError();
		return FALSE;
	}else return TRUE;
}

