#ifndef __TEXTWINDOW_H__
#define __TEXTWINDOW_H__

class TextWindow : public CWindowImpl<TextWindow>
{
public:
	TextWindow() : m_height(-1),m_width(-1),m_x(0),m_y(0),m_isshow(true){}
	~TextWindow(){Destroy();}
	DECLARE_WND_CLASS(_T("ForTeXTextWindow"));
	intptr_t Create(HWND hwnd, intptr_t x, intptr_t y,const TCHAR *text);
	intptr_t SetSize(intptr_t height, intptr_t width){m_height = height;m_width = width;return TRUE;}
	intptr_t SetPos(intptr_t x, intptr_t y){m_x = x;m_y = y;return TRUE;}
	intptr_t SetShow(intptr_t b){m_isshow = b?true:false;return TRUE;}
	intptr_t SetText(const TCHAR *text){m_text = text;return TRUE;}
	intptr_t Update();
	intptr_t SetFont(const TCHAR *fontname, intptr_t fontsize){m_fontname = fontname;m_fontsize = fontsize;SetCFont();return TRUE;}
	intptr_t Destroy(){if(::IsWindow(m_hWnd) && ::DestroyWindow(m_hWnd))return TRUE;else{::SetmacrodllLastError();return FALSE;}}
	intptr_t GetWindowHeight();
	intptr_t GetWindowWidth();


private:
	BEGIN_MSG_MAP_EX(TextWindow)
		MSG_WM_CREATE(OnCreate);
		MSG_WM_PAINT(OnPaint);
		MSG_WM_DESTROY(OnDestroy);
	END_MSG_MAP()

	LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct);
	void OnPaint(HDC /*hDC*/);
	void OnDestroy();

	bool m_isshow;
	ablib::string m_text;
	intptr_t m_x,m_y,m_width,m_height;

	ablib::string m_fontname;
	intptr_t m_fontsize;
	TEXTMETRIC m_fontdata;
	WTL::CFont m_font,m_boldfont;
	void SetCFont();
	// svZ֐DłႤƂłD
	void CalcDrawText(WTL::CDC &dc,bool draw, intptr_t &width, intptr_t &line);

	HWND m_parent;

	ablib::string Escape(const TCHAR *s);
};

#endif //__TEXTWINDOW_H__


