/** @file cmd2.c
* @brief R\[obt@ύXđăR}hsD
* @author ABE Noriyuki
* 
* ispellg߂ɊԂɋ݂܂D
* Copyright (C) ABE Noriyuki
*/


#include <windows.h>
#include <tchar.h>

#define CONSOLEBUFFER_X 80
#define CONSOLEBUFFER_Y 25

#ifdef UNICODE
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLineA,int nCmdShow){
	TCHAR *lpCmdLine = (TCHAR *)lpCmdLineA;
#else
int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow){
#endif
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	COORD coord;
	HANDLE hstdout;
	TCHAR buf[4096];
	DWORD exitcode;

	if(!AllocConsole())return 1;

	coord.X = CONSOLEBUFFER_X;
	coord.Y = CONSOLEBUFFER_Y;
	hstdout = GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleScreenBufferSize(hstdout,coord);

	si.cb = sizeof(STARTUPINFO);
	si.dwFlags = STARTF_USESHOWWINDOW;
	GetStartupInfo(&si);
	si.wShowWindow = SW_SHOW;
	si.dwXCountChars = CONSOLEBUFFER_X;
	si.dwYCountChars = CONSOLEBUFFER_Y;
	
	pi.hProcess = pi.hThread = NULL;
	pi.dwProcessId = pi.dwThreadId = 0;
	
	GetCurrentDirectory(4095,buf);
	if(!CreateProcess(NULL,lpCmdLine,NULL,NULL,TRUE,DETACHED_PROCESS,NULL,buf,&si,&pi)){
		wsprintf(buf,"%d",GetLastError());
		MessageBox(NULL,buf,NULL,0);
		FreeConsole();
		return 1;
	}
	CloseHandle(pi.hThread);
	WaitForSingleObject(pi.hProcess,INFINITE);
	GetExitCodeProcess(pi.hProcess,&exitcode);
	CloseHandle(pi.hProcess);
	FreeConsole();
	return exitcode;
}


void __cdecl WinMainCRTStartup( void ){
	TCHAR *lpszCommandLine;
//	STARTUPINFO StartupInfo;

	lpszCommandLine = GetCommandLine();

	if ( *lpszCommandLine == '"' ){
		do{
			lpszCommandLine++;
		}while( *lpszCommandLine && (*lpszCommandLine != '"') );
		
		if ( *lpszCommandLine == '"' )lpszCommandLine++;
		}else{
			while ( *lpszCommandLine > ' ' )lpszCommandLine++;
	}

	while ( *lpszCommandLine && (*lpszCommandLine <= ' ') )lpszCommandLine++;

//	StartupInfo.dwFlags = 0;
//	GetStartupInfo( &StartupInfo );

	ExitProcess(WinMain( NULL,//ǂgȂcc
	NULL,
	(LPSTR)lpszCommandLine,0));//gȂc
//	StartupInfo.dwFlags & STARTF_USESHOWWINDOW
//	? StartupInfo.wShowWindow : SW_SHOWDEFAULT );
}
